require 'csv'

def save_contacts contacts=[], filename="contacts.csv"
   CSV.open filename, "w" do |csv|
      contacts.each do |contact|
	 csv << contact.values
      end
   end
end

def load_contacts filename="contacts.csv"
   CSV.foreach( filename ).map do |contact_csv|
      { id: contact_csv[0].to_i, name: contact_csv[1], mobile: contact_csv[2] }
   end
end

require 'minitest/autorun'
def to_contacts_saved_in filename
   to_contacts_saved filename
end

def to_contacts_saved filename="contacts.csv"
   CSV.foreach( filename ).map do |contact_csv|
      { id: contact_csv[0].to_i, name: contact_csv[1], mobile: contact_csv[2] }
   end
end
describe "save_contacts" do
   it "envia los contactos a CSV" do
      contacts = [
	 {id: 1, name: "Juan Perez", mobile: "123123"},
	 {id: 2, name: "Jorge Bolaños", mobile: "321321"}
      ]

      save_contacts contacts

      contacts.must_equal to_contacts_saved
   end
   describe "cuando recibe nombre de fichero donde almacenar" do
      it "almacena los datos de los contactos en el fichero ingresado" do
	 contacts = [
	    {id: 1, name: "Juan Perez", mobile: "123123"},
	    {id: 2, name: "Jorge Bolaños", mobile: "321321"}
	 ]
	 
	 filename = "contacts-store.csv"

	 save_contacts contacts, filename

	 contacts.must_equal to_contacts_saved_in( filename )
      end
   end

end

describe "load_contacts" do
   it "lee los datos de CSV" do
      contacts_expected = [
	 {id: 1, name: "Juan Perez", mobile: "123123"},
	 {id: 2, name: "Jorge Bolaños", mobile: "321321"}
      ]
      load_contacts.must_equal contacts_expected
   end
   
   describe "cuando recibe nombre de fichero donde están almacenados los datos" do
      it "carga los datos del fichero indicado" do
	 filename = from_filename = "contacts-store.csv"
	 load_contacts( from_filename ).must_equal to_contacts_saved_in( filename )
      end
   end
end
